<?php
/*
* Nanodatabase query. Credits an Vhab's Items query, which was the base for this module.
* Also credits to Jayde, Auno, Arpa and Jihalvo, whose data was the framework for this DB
* Further thanks to AOWiki.eu and ao-universe.com.
* Webquery at http://www.ao-nanodb.com
* Created 14.08.2007, by Faldon (RK3)
* Last edit 13.03.2008
*/

$FixersInc = new FixersInc($bot);

class FixersInc extends BaseActiveModule
        {
        var $server = 'http://www.ao-nanodb.com';
        var $prof_list = array ('adv' => 'Adventurer', 'agent' => 'Agent', 'crat' => 'Bureaucrat', 'doc' => 'Doctor', 'enfo' => 'Enforcer', 'engi' => 'Engineer', 'fixer' => 'Fixer', 'keeper' => 'Keeper', 'ma' => 'Martial Artist', 'mp' => 'Meta-Physicist', 'nt' => 'Nano-Technician', 'soli' => 'Soldier', 'shade' => 'Shade', 'trader' => 'Trader');
        var $store_list = array ('shop' => 'Buyable', 'missi' => 'Rollable', 'dyna' => 'Dyna-,Chestloot', 'quest' => 'Questable');
        var $bot;

        function __construct(&$bot)
            {
            parent::__construct(&$bot, get_class($this));

            $this -> register_command('all', 'nano', 'GUEST');
            
            $this -> help['description'] = 'Lists the locations of Nano Crystals. The database stores the Nano Crystals, so you must not search for Nano Formula names. The Nano Formula "Improved Semi-Sentient Augmentation Cloud" e.g. is stored as "Weird Looking Semi-Sentient Augmentation Cloud". AI NT Dots and MP / Trader PET are also stored as Crystal Name or rather as Business Card!';
            $this -> help['command']['nano <searchstring>']="Searches for <searchstring> in the Nanodatabase and lists all found nanos and their location.";
            $this -> help['command']['nano <profession>']="Lists all nanos of <profession> sortet by QL.";
            $this -> help['command']['nano <profession> <location>']="Lists all nanos of <profession> found at <location>.";
            $this -> help['notes']="Allowed profession: adv,agent,crat,doc,enfo,engi,fixer,keeper,ma,mp,nt,shade,soli,trader.<br>Allowed location: shop,dyna,missi,quest. ";
            }

			function command_handler($name, $msg, $origin)
            {
            if (preg_match('/^nano/i', $msg, $info)) {
                $words = trim(substr($msg, strlen('nano')));
                if (!empty($words)) {
                    $parts = explode(' ', $words);
                        if (count($parts) > 1 && array_key_exists($parts[0], $this -> prof_list) && array_key_exists($parts[1], $this -> store_list)) {
                            $profession = $this -> prof_list[$parts[0]];
                            $availabillity = $this -> store_list[$parts[1]];
                            unset($parts[0], $parts[1]);
                            $search = implode(' ', $parts);
                            }
                        elseif (count($parts) == 1 && array_key_exists($parts[0], $this -> prof_list)) {
                            $profession = $this -> prof_list[$parts[0]];
                            unset($parts[0]);
                            }
                        else {
                            $search = implode(' ', $parts);
                            }
                    $url = $this -> server;
                    $url .= '/IG_nanolist.php?';
                    $url .= 'searchstring='.urlencode($search);
                    if (isset($profession)) {
                        $url .= '&prof='.urlencode($profession);
                        }
                    if (isset($availabillity)) {
                        $url .= '&store='.urlencode($availabillity);
                        }
                    $result = $this -> bot -> core("tools") -> get_site($url, 1);
                    if (!empty($result["content"])) {
                        return $result["content"];
                        }
                    else {
                        return "DB query not possible.";
                        }
                    }
			else {
				return "Usage: !nano [searchstring] or read the help for more options.";
			}
		}


	else {
			$this -> bot -> send_help($name);
		}
	}
}
?>